import * as Promise from 'bluebird';
import { I18nBundle } from 'pretur.i18n';
export interface OperationPayload<T> {
    name: string;
    data?: T;
}
export interface OperationResponse<T> {
    name: string;
    data?: T;
    errors?: I18nBundle[];
}
export interface Operator {
    (payload: OperationPayload<any>): Promise<OperationResponse<any>>;
}
export interface Operation<TPayload, TReponse> {
    name: string;
    is(payload: OperationPayload<any>): payload is OperationPayload<TPayload>;
    is(response: OperationResponse<any>): response is OperationResponse<TReponse>;
    execute(operator: Operator, payload?: TPayload): Promise<OperationResponse<TReponse>>;
}
export declare function buildOperator(endPointUrl: string): Operator;
export declare function buildOperation<TPayload, TReponse>(name: string): Operation<TPayload, TReponse>;
