import * as Promise from 'bluebird';
import { Query } from 'pretur.sync';
import { Model } from 'pretur.spec';
import { Pool } from './pool';
export interface ResolveResult<T> {
    data: T[];
    count?: number;
}
export interface Resolver<T> {
    (query: Query): Promise<ResolveResult<T>>;
}
export interface UnitializedResolver<T> {
    resolver: Resolver<T>;
    initialize(pool: Pool): void;
}
export interface ResolveInterceptor<T> {
    (query: Query, result: ResolveResult<T>): Promise<ResolveResult<T>>;
}
export interface BuildResolverOptions<T> {
    intercept?: ResolveInterceptor<T>;
    queryTransformer?(query: Query): Query;
}
export declare function buildResolver<T>(spec: Model, options?: BuildResolverOptions<T>): UnitializedResolver<T>;
